=== modified file 'console/python-console'
--- console/python-console	2008-01-31 05:16:36 +0000
+++ console/python-console	2008-01-31 08:11:37 +0000
@@ -3,15 +3,15 @@
 # usage:
 #   python-console <port> <magic>
 
-import sys
-import web
-import md5
+import cjson
 import codeop
-import cjson
-import cgi
 import cStringIO
+import md5
+import os
+import Queue
 import signal
-import Queue
+import socket
+import sys
 from threading import Thread
 
 class StdinFromWeb(object):
@@ -59,7 +59,6 @@
                         # The command was complete,
                         # so evaluate it!
                         sys.stdin = StdinFromWeb(self.cmdQ, self.lineQ)
-                        self.out = cStringIO.StringIO()
                         sys.stdout = self.out
                         sys.stderr = self.out
                         signal.alarm(5)
@@ -67,28 +66,32 @@
                         signal.alarm(0)
                         self.cmdQ.put({"okay":(self.out.getvalue(),res)})
                         self.curr_cmd = ''
+                        self.out = cStringIO.StringIO()
                 except Exception, exc:
                     signal.alarm(0)
                     self.cmdQ.put({"exc":(self.out.getvalue(),str(exc))})
                     self.curr_cmd = ''
+                    self.out = cStringIO.StringIO()
             if 'block' in ln:
                 # throw away a partial command.
-                self.curr_cmd = ''
                 try:
                     cmd = compile(ln['block'], "<web session>", 'exec');
                     
                     sys.stdin = StdinFromWeb(self.cmdQ, self.lineQ)
                     self.out = cStringIO.StringIO()
-                    sys.stdout = out
-                    sys.stderr = out
+                    sys.stdout = self.out
+                    sys.stderr = self.out
                     signal.alarm(5)
                     res = eval(cmd, self.globs, self.locls)
                     signal.alarm(0)
                     self.cmdQ.put({"okay":(self.out.getvalue(),res)})
                     self.curr_cmd = ''
+                    self.out = cStringIO.StringIO()
                 except Exception, exc:
                     signal.alarm(0)
                     self.cmdQ.put({"exc":(self.out.getvalue(),str(exc))})
+                    self.curr_cmd = ''
+                    self.out = cStringIO.StringIO()
 
     def init_state(self):
         self.globs = {}
@@ -96,61 +99,65 @@
         self.locls = {}
         self.curr_cmd = ''
 
-urls = (
-    '/chat',        'chat',
-    '/block',       'block')
+def daemonize():
+    if os.fork():   # launch child and...
+        os._exit(0) # kill off parent
+    os.setsid()
+    if os.fork():   # launch child and...
+        os._exit(0) # kill off parent again.
+    os.umask(077)
 
 # The global 'magic' is the secret that the client and server share
 # which is used to create and md5 digest to authenticate requests.
 # It is assigned a real value at startup.
 magic = ''
 
-class chat:
-
-    def POST(self):
-        inp = web.input()
-
-        # Authenticate
-        digest = md5.new(inp.text + magic).digest().encode('hex')
-        if inp.digest != digest:
-            web.output("401 Unauthorized")
-            web.ctx.status = '401 Unauthorized'
-            return
-
-        # Okay, so the authentication succeeded,
-        # so now we have the trivial matter of actually
-        # executing the python....
-        lineQ.put({'chat':inp.text})
-        r = cmdQ.get()
-        sys.__stderr__.write(cjson.encode(r) + "\n")
-        web.output(cjson.encode(r))
-
-class block:
-
-    def POST(self):
-        inp = web.input()
-
-        # Authenticate
-        digest = md5.new(inp.text + magic).digest().encode('hex')
-        if inp.digest != digest:
-            web.output("401 Unauthorized")
-            web.ctx.status = '401 Unauthorized'
-            return
-
-        # Okay, so the authentication succeeded,
-        # so now we have the trivial matter of actually
-        # executing the python....
-        lineQ.put({'block':inp.text})
-        r = cmdQ.get()
-        sys.__stderr__.write(cjson.encode(r) + "\n")
-        web.output(cjson.encode(r))
-
 cmdQ = Queue.Queue()
 lineQ = Queue.Queue()
 interpThread = PythonRunner(cmdQ, lineQ)
 
 if __name__ == "__main__":
+    port = int(sys.argv[1])
     magic = sys.argv[2]
+
+    # Attempt to open the socket.
+    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
+    s.bind(('', port))
+    s.listen(1)
+
+    # Excellent! It worked. Let's turn ourself into a daemon,
+    # then get on with the job of being a python interpreter.
+    daemonize()
+
     interpThread.setDaemon(True)
     interpThread.start()
-    web.run(urls, globals())
+
+    while True:
+        (conn, addr) = s.accept()
+        try:
+            # Grab the input
+            buf = cStringIO.StringIO()
+            blk = conn.recv(1024)
+            while blk:
+                buf.write(blk)
+                try:
+                    blk = conn.recv(1024, socket.MSG_DONTWAIT)
+                except:
+                    # Exception thrown if it WOULD block (but we
+                    # told it not to wait) - ie. we are done
+                    blk = None
+            inp = buf.getvalue()
+            msg = cjson.decode(inp)
+            
+            # Check that the message is 
+            digest = md5.new(msg['text'] + magic).digest().encode('hex')
+            if msg['digest'] != digest:
+                conn.close()
+                continue
+
+            lineQ.put({msg['cmd']:msg['text']})
+            r = cmdQ.get()
+            conn.sendall(cjson.encode(r))
+            conn.close()
+        except Exception, e:
+            conn.close()

=== modified file 'www/apps/consoleservice/__init__.py'
--- www/apps/consoleservice/__init__.py	2008-01-23 06:55:12 +0000
+++ www/apps/consoleservice/__init__.py	2008-01-31 08:11:37 +0000
@@ -19,10 +19,16 @@
 # Author: Matt Giuca, Tom Conway
 # Date: 14/1/2008
 
+import cStringIO
+import httplib
+import md5
 import os
 import pwd
-import httplib
+import random
+import socket
+import sys
 import urllib
+import uuid
 
 import cjson
 
@@ -45,6 +51,8 @@
         handle_start(req)
     elif req.path == "chat":
         handle_chat(req)
+    #elif req.path == "block":
+    #    handle_block(req)
     else:
         req.throw_error(req.HTTP_BAD_REQUEST)
 
@@ -67,24 +75,42 @@
     # TODO: Figure out the host name the console server is running on.
     host = req.hostname
 
-    # Find an available port on the server.
-    # TODO
-    port = 1025
-
     # Create magic
     # TODO
-    magic = "xyzzy"
-
-    # Start the console server (port, magic)
-    # trampoline usage: tramp uid jail_dir working_dir script_path args
-    # console usage:    python-console port magic
-    # TODO: Cleanup (don't use os.system)
-    # TODO: Pass working_dir as argument, let console cd to it
-    # Use "&" to run as a background process
-    cmd = ' '.join([trampoline_path, str(uid), jail_path, console_dir,
-        python_path, console_path, str(port), str(magic), "&"])
-    #req.write(cmd + '\n')
-    os.system(cmd)
+    magic = md5.new(uuid.uuid4().bytes).digest().encode('hex')
+
+    # Try to find a free port on the server.
+    # Just try some random ports in the range [3000,8000)
+    # until we either succeed, or give up. If you think this
+    # sounds risky, it isn't:
+    # For N ports (e.g. 5000) with k (e.g. 100) in use, the
+    # probability of failing to find a free port in t (e.g. 5) tries
+    # is (k / N) ** t (e.g. 3.2*10e-9).
+
+    tries = 0
+    while tries < 5:
+        port = int(random.uniform(3000, 8000))
+
+        # Start the console server (port, magic)
+        # trampoline usage: tramp uid jail_dir working_dir script_path args
+        # console usage:    python-console port magic
+        # TODO: Pass working_dir as argument, let console cd to it
+        cmd = ' '.join([trampoline_path, str(uid), jail_path,
+                            console_dir, python_path, console_path,
+                            str(port), str(magic)])
+
+        print >> sys.stderr, cmd
+        res = os.system(cmd)
+        print >> sys.stderr, res
+
+        if res == 0:
+            # success
+            break;
+
+        tries += 1
+
+    if tries == 5:
+        raise Exception, "unable to find a free port!"
 
     # Return port, magic
     req.write(cjson.encode({"host": host, "port": port, "magic": magic}))
@@ -99,7 +125,7 @@
     fields = req.get_fieldstorage()
     try:
         host = fields.getfirst("host").value
-        port = fields.getfirst("port").value
+        port = int(fields.getfirst("port").value)
         digest = fields.getfirst("digest").value
     except AttributeError:
         # Any of the getfirsts returned None
@@ -110,23 +136,26 @@
     except AttributeError:
         text = ""
 
-    # Open an HTTP connection
-    url = ("http://" + urllib.quote(host) + ":" + urllib.quote(port)
-            + "/chat");
-    body = ("digest=" + urllib.quote(digest)
-            + "&text=" + urllib.quote(text))
-    headers = {"Content-Type": "application/x-www-form-urlencoded"}
-    try:
-        conn = httplib.HTTPConnection(host, port)
-    except:
-        req.throw_error(req.HTTP_BAD_REQUEST)
-    conn.request("POST", url, body, headers)
-
-    response = conn.getresponse()
+    msg = {'cmd':'chat', 'text':text, 'digest':digest}
+
+    sok = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
+    sok.connect((host, port))
+    sok.send(cjson.encode(msg))
+
+    buf = cStringIO.StringIO()
+    blk = sok.recv(1024)
+    while blk:
+        buf.write(blk)
+        try:
+            blk = conn.recv(1024, socket.MSG_DONTWAIT)
+        except:
+            # Exception thrown if it WOULD block (but we
+            # told it not to wait) - ie. we are done
+            blk = None
+    inp = buf.getvalue()
     
-    req.status = response.status
-    # NOTE: Ignoring arbitrary headers returned by the server
-    # Probably not necessary to proxy them
-    req.content_type = response.getheader("Content-Type", "text/plain")
-    req.write(response.read())
-    conn.close()
+    sok.close()
+
+    req.content_type = "text/plain"
+    req.write(inp)
+

=== modified file 'www/media/console/console.js'
--- www/media/console/console.js	2008-01-31 05:13:17 +0000
+++ www/media/console/console.js	2008-01-31 08:11:37 +0000
@@ -99,12 +99,6 @@
     console_filler.setAttribute("class", "windowpane maximal");
 }
 
-/* Below here imported from trunk/console/console.js
- * (Tom Conway)
- */
-
-var magic = 'xyzzy';
-
 /* current_text is the string currently on the command line.
  * If non-empty, it will be stored at the bottom of the history.
  */
@@ -213,7 +207,7 @@
 {
     /* Start the server if it hasn't already been started */
     start_server();
-    var digest = hex_md5(inputline + magic);
+    var digest = hex_md5(inputline + server_magic);
     var args = {"host": server_host, "port": server_port,
                     "digest":digest, "text":inputline};
     var xmlhttp = ajax_call("consoleservice", "chat", args, "POST");

